/**
 * 
 */
package rs.in.jmax.managebean;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import org.richfaces.model.DataProvider;
import org.richfaces.model.ExtendedTableDataModel;

import rs.in.jmax.managebean.bean.Book;

/**
 * @author Vlade Maksimovic
 * 
 */
@ManagedBean
@SessionScoped
public class BookMNB implements Serializable{

	private static final long serialVersionUID = -3049414051466686217L;
	private List<Book> books;
	private ExtendedTableDataModel<Book> dataModel;

	public BookMNB() {
		System.out.println("construktor");
		books = new ArrayList<Book>();
		Book book = new Book();
		book.setId(1);
		book.setName("name");
		books.add(book);
		
        dataModel = null;
        ExtendedTableDataModel<Book> newDataModel = getDataModel();
        dataModel = newDataModel;
	}

    /**
     * @return EGM data model that is binded to extended data table in EGM search form
     */
    public ExtendedTableDataModel<Book> getDataModel() {
    	System.out.println("getDataModel");
        if (dataModel == null) {
            dataModel = new ExtendedTableDataModel<Book>(new DataProvider<Book>() {
                private static final long serialVersionUID = 699310302393961134L;
                public Book getItemByKey(Object key) {
                    for (Book book : books) {
                        if (key.equals(getKey(book))) {
                            return book;
                        }
                    }
                    return null;
                }
                public List<Book> getItemsByRange(int firstRow, int endRow) {
                    return books.subList(firstRow, endRow);
                }
                public Object getKey(Book item) {
                    return item.getId();
                }
                public int getRowCount() {
                    return books.size();
                }
            });
        }
        return dataModel;
    }	
	
}
